// The Developer of the Original Code is Aki Goto <harpy@lily.freemail.ne.jp>
// to and including version 1.4

// Contributor: George A. Booth <booth.g@gmail.com>
// versions 1.5, 1.6

// Copyright licence is MPL 1.1/GPL 2.0/LGPL 2.1


function rimwheel_settings_onload()
{


// set bit masks

	const topleft=128;
	const topmiddle=64;
	const topright=32;
	const middleleft=16;
	const middleright=8;
	const bottomleft=4;
	const bottommiddle=2;
	const bottomright=1;

	var prefs = Components.classes["@mozilla.org/preferences-service;1"]
		.getService(Components.interfaces.nsIPrefService)
		.getBranch("extensions.rimwheel.");

	var enable_grid;

	document.getElementById("rimwheel_settings_enabled").checked
		= rimwheel_getBoolPref(prefs, "enabled", true);
	document.getElementById("rimwheel_settings_rimsize").value
		= rimwheel_getIntPref(prefs, "rimsize", 64);
	document.getElementById("rimwheel_settings_pageratio").value
		= rimwheel_getCharPref(prefs, "pageratio", 0.9);
	document.getElementById("rimwheel_settings_scrollsize").value
		= rimwheel_getIntPref(prefs, "scrollsize", 48);

	enable_grid = rimwheel_getIntPref(prefs, "grid", 255);


// unpack the grid preference - I punched fortran decks, I love this.

	document.getElementById("grid_topleft").checked = !( enable_grid & topleft );
	document.getElementById("grid_topmiddle").checked = !( enable_grid & topmiddle );
	document.getElementById("grid_topright").checked = !( enable_grid & topright );
	document.getElementById("grid_middleleft").checked = !( enable_grid & middleleft );
	document.getElementById("grid_middleright").checked = !( enable_grid & middleright );
	document.getElementById("grid_bottomleft").checked = !( enable_grid & bottomleft );
	document.getElementById("grid_bottommiddle").checked = !( enable_grid & bottommiddle );
	document.getElementById("grid_bottomright").checked = !( enable_grid & bottomright );

}

function rimwheel_getBoolPref(prefs, name, d)
{
	if (prefs.prefHasUserValue(name))
		return prefs.getBoolPref(name);
	else
		return d;
}

function rimwheel_getIntPref(prefs, name, d)
{
	if (prefs.prefHasUserValue(name))
		return prefs.getIntPref(name);
	else
		return d;
}

function rimwheel_getCharPref(prefs, name, d)
{
	if (prefs.prefHasUserValue(name))
		return prefs.getCharPref(name);
	else
		return d;
}

function rimwheel_settings_ondialogaccept()
{
	if (document.getElementById("rimwheel_settings_clear").checked) {
		rimwheel_settings_clear();
	} else {
		rimwheel_settings_update();
	}
}

function rimwheel_settings_update()
{

// set bit masks

	const topleft=128;
	const topmiddle=64;
	const topright=32;
	const middleleft=16;
	const middleright=8;
	const bottomleft=4;
	const bottommiddle=2;
	const bottomright=1;

	var enable_grid;

	var prefs = Components.classes["@mozilla.org/preferences-service;1"]
		.getService(Components.interfaces.nsIPrefService)
		.getBranch("extensions.rimwheel.");

	
	prefs.setBoolPref("enabled",
		document.getElementById("rimwheel_settings_enabled").checked);
	prefs.setIntPref("rimsize",
		document.getElementById("rimwheel_settings_rimsize").value);


// unpack the grid preference - I punched fortran decks, I love this.

 	enable_grid =
 	(!( document.getElementById("grid_topleft").checked )* topleft ) +
 	(!( document.getElementById("grid_topmiddle").checked )* topmiddle ) +
 	(!( document.getElementById("grid_topright").checked )* topright ) +
 	(!( document.getElementById("grid_middleleft").checked )* middleleft ) +
 	(!( document.getElementById("grid_middleright").checked )* middleright ) +
 	(!( document.getElementById("grid_bottomleft").checked )* bottomleft ) +
 	(!( document.getElementById("grid_bottommiddle").checked )* bottommiddle ) +
 	(!( document.getElementById("grid_bottomright").checked )* bottomright );


 	prefs.setIntPref("grid", enable_grid);

	prefs.setCharPref("pageratio",
		document.getElementById("rimwheel_settings_pageratio").value);
	prefs.setIntPref("scrollsize",
		document.getElementById("rimwheel_settings_scrollsize").value);


}

function rimwheel_settings_clear()
{
	var prefs = Components.classes["@mozilla.org/preferences-service;1"]
		.getService(Components.interfaces.nsIPrefService)
		.getBranch("extensions.rimwheel.");

	try {
		prefs.clearUserPref("enabled");
	} catch (e) { }
	try {
		prefs.clearUserPref("rimsize");
	} catch (e) { }
	try {
		prefs.clearUserPref("pageratio");
	} catch (e) { }
	try {
		prefs.clearUserPref("scrollsize");
	} catch (e) { }
	try {
		prefs.clearUserPref("grid");
	} catch (e) { }

	try {
	  prefs.clearUserPref("upperleft_up");
	} catch (e) { }
	try {
	  prefs.clearUserPref("upperleft_down");
	} catch (e) { }
	try {
	  prefs.clearUserPref("upper_up");
	} catch (e) { }
	try {
	  prefs.clearUserPref("upper_down");
	} catch (e) { }
	try {
	  prefs.clearUserPref("upperright_up");
	} catch (e) { }
	try {
	  prefs.clearUserPref("upperright_down");
	} catch (e) { }
	try {
	  prefs.clearUserPref("left_up");
	} catch (e) { }
	try {
	  prefs.clearUserPref("left_down");
	} catch (e) { }
	try {
	  prefs.clearUserPref("center_up");
	} catch (e) { }
	try {
	  prefs.clearUserPref("center_down");
	} catch (e) { }
	try {
	  prefs.clearUserPref("right_up");
	} catch (e) { }
	try {
	  prefs.clearUserPref("right_down");
	} catch (e) { }
	try {
	  prefs.clearUserPref("lowerleft_up");
	} catch (e) { }
	try {
	  prefs.clearUserPref("lower_down");
	} catch (e) { }
	try {
	  prefs.clearUserPref("lower_up");
	} catch (e) { }
	try {
	  prefs.clearUserPref("lower_down");
	} catch (e) { }
	try {
	  prefs.clearUserPref("lowerright_up");
	} catch (e) { }
	try {
	  prefs.clearUserPref("lowerright_down");
	} catch (e) { }
}

function rimwheel_open_editor(section)
{
  openDialog('chrome://rimwheel/content/editor.xul', null,
	     'modal, centerscreen, resizable', section);
}

var rimwheel_defaults =
  {
    upperleft_up: "BrowserStop();",
    upperleft_down: "BrowserReload();",
    upper_up: "gBrowser.tabContainer.advanceSelectedTab(1, true);",
    upper_down: "gBrowser.tabContainer.advanceSelectedTab(-1, true);",
    upperright_up:
    "if (gBrowser.tabContainer.childNodes.length > 1)\n"
    + "  gBrowser.removeCurrentTab();\n"
    + "else\n"
    + "  ; // nothing",
    upperright_down: "delayedOpenTab();",
    left_up: "BrowserBack();",
    left_down: "BrowserForward();",
    center_up: "/* dummy */",
    center_down: "/* dummy */",
    right_up:
    "var w = e.target.ownerDocument.defaultView;\n"
    + "w.scrollBy(0, -w.innerHeight * rimwheel_pageratio);",
    right_down:
    "var w = e.target.ownerDocument.defaultView;\n"
    +"w.scrollBy(0, w.innerHeight * rimwheel_pageratio);",
    lowerleft_up: "getWebNavigation().gotoIndex(0);",
    lowerleft_down:
    "getWebNavigation().gotoIndex"
    + "(getWebNavigation().sessionHistory.count - 1);",
    lower_up:
    "e.target.ownerDocument.defaultView.scrollBy"
    + "(-rimwheel_scrollsize, 0);",
    lower_down:
    "e.target.ownerDocument.defaultView.scrollBy"
    + "(rimwheel_scrollsize, 0);",
    lowerright_up:
    "var w = e.target.ownerDocument.defaultView;\n"
    + "w.scrollTo(w.scrollX, 0);",
    lowerright_down:
    "var w = e.target.ownerDocument.defaultView;\n"
    + "w.scrollTo(w.scrollX, w.scrollMaxY);",
  };

function rimwheel_editor_onload()
{
  var prefs = Components.classes["@mozilla.org/preferences-service;1"]
    .getService(Components.interfaces.nsIPrefService)
    .getBranch("extensions.rimwheel.");

  var section = window.arguments[0];

  document.getElementById("upcode").value
    = rimwheel_getCharPref(prefs, section+"_up",
			   rimwheel_defaults[section+"_up"]);
  document.getElementById("downcode").value
    = rimwheel_getCharPref(prefs, section+"_down",
			   rimwheel_defaults[section+"_down"]);
}

function rimwheel_close_editor(fields)
{
  var prefs = Components.classes["@mozilla.org/preferences-service;1"]
  .getService(Components.interfaces.nsIPrefService)
  .getBranch("extensions.rimwheel.");

  var section = window.arguments[0];

  prefs.setCharPref
    (section+"_up", document.getElementById("upcode").value);
  prefs.setCharPref
    (section+"_down", document.getElementById("downcode").value);
}
